/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// AuditRecord struct for AuditRecord
type AuditRecord struct {
	// The action performed on the resource.
	ActionType     string `json:"action_type"`
	ActorAvatarUrl string `json:"actor_avatar_url"`
	// The display name of an actor.
	ActorDisplayName string `json:"actor_display_name"`
	// The handle name of an actor.
	ActorHandle string `json:"actor_handle"`
	// The unique identifier of an actor.
	ActorId string `json:"actor_id"`
	ActorIp string `json:"actor_ip"`
	// The time when the audit log was recorded.
	CreatedAt string                 `json:"created_at"`
	Data      map[string]interface{} `json:"data"`
	// The unique identifier for an audit log.
	Id string `json:"id"`
	// The handle name for an identity where the action has been performed.
	IdentityHandle string `json:"identity_handle"`
	// The unique identifier for an identity where the action has been performed.
	IdentityId string  `json:"identity_id"`
	ProcessId  *string `json:"process_id,omitempty"`
	// The handle name of the entity on which the action has been performed.
	TargetHandle *string `json:"target_handle,omitempty"`
	// The unique identifier of the entity on which the action has been performed.
	TargetId *string `json:"target_id,omitempty"`
	// The unique identifier for the where the action has been performed.
	TenantId string `json:"tenant_id"`
}

// NewAuditRecord instantiates a new AuditRecord object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAuditRecord(actionType string, actorAvatarUrl string, actorDisplayName string, actorHandle string, actorId string, actorIp string, createdAt string, data map[string]interface{}, id string, identityHandle string, identityId string, tenantId string) *AuditRecord {
	this := AuditRecord{}
	this.ActionType = actionType
	this.ActorAvatarUrl = actorAvatarUrl
	this.ActorDisplayName = actorDisplayName
	this.ActorHandle = actorHandle
	this.ActorId = actorId
	this.ActorIp = actorIp
	this.CreatedAt = createdAt
	this.Data = data
	this.Id = id
	this.IdentityHandle = identityHandle
	this.IdentityId = identityId
	this.TenantId = tenantId
	return &this
}

// NewAuditRecordWithDefaults instantiates a new AuditRecord object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAuditRecordWithDefaults() *AuditRecord {
	this := AuditRecord{}
	return &this
}

// GetActionType returns the ActionType field value
func (o *AuditRecord) GetActionType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ActionType
}

// GetActionTypeOk returns a tuple with the ActionType field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetActionTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ActionType, true
}

// SetActionType sets field value
func (o *AuditRecord) SetActionType(v string) {
	o.ActionType = v
}

// GetActorAvatarUrl returns the ActorAvatarUrl field value
func (o *AuditRecord) GetActorAvatarUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ActorAvatarUrl
}

// GetActorAvatarUrlOk returns a tuple with the ActorAvatarUrl field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetActorAvatarUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ActorAvatarUrl, true
}

// SetActorAvatarUrl sets field value
func (o *AuditRecord) SetActorAvatarUrl(v string) {
	o.ActorAvatarUrl = v
}

// GetActorDisplayName returns the ActorDisplayName field value
func (o *AuditRecord) GetActorDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ActorDisplayName
}

// GetActorDisplayNameOk returns a tuple with the ActorDisplayName field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetActorDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ActorDisplayName, true
}

// SetActorDisplayName sets field value
func (o *AuditRecord) SetActorDisplayName(v string) {
	o.ActorDisplayName = v
}

// GetActorHandle returns the ActorHandle field value
func (o *AuditRecord) GetActorHandle() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ActorHandle
}

// GetActorHandleOk returns a tuple with the ActorHandle field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetActorHandleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ActorHandle, true
}

// SetActorHandle sets field value
func (o *AuditRecord) SetActorHandle(v string) {
	o.ActorHandle = v
}

// GetActorId returns the ActorId field value
func (o *AuditRecord) GetActorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ActorId
}

// GetActorIdOk returns a tuple with the ActorId field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetActorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ActorId, true
}

// SetActorId sets field value
func (o *AuditRecord) SetActorId(v string) {
	o.ActorId = v
}

// GetActorIp returns the ActorIp field value
func (o *AuditRecord) GetActorIp() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ActorIp
}

// GetActorIpOk returns a tuple with the ActorIp field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetActorIpOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ActorIp, true
}

// SetActorIp sets field value
func (o *AuditRecord) SetActorIp(v string) {
	o.ActorIp = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *AuditRecord) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *AuditRecord) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetData returns the Data field value
func (o *AuditRecord) GetData() map[string]interface{} {
	if o == nil {
		var ret map[string]interface{}
		return ret
	}

	return o.Data
}

// GetDataOk returns a tuple with the Data field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetDataOk() (*map[string]interface{}, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Data, true
}

// SetData sets field value
func (o *AuditRecord) SetData(v map[string]interface{}) {
	o.Data = v
}

// GetId returns the Id field value
func (o *AuditRecord) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *AuditRecord) SetId(v string) {
	o.Id = v
}

// GetIdentityHandle returns the IdentityHandle field value
func (o *AuditRecord) GetIdentityHandle() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.IdentityHandle
}

// GetIdentityHandleOk returns a tuple with the IdentityHandle field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetIdentityHandleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.IdentityHandle, true
}

// SetIdentityHandle sets field value
func (o *AuditRecord) SetIdentityHandle(v string) {
	o.IdentityHandle = v
}

// GetIdentityId returns the IdentityId field value
func (o *AuditRecord) GetIdentityId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.IdentityId
}

// GetIdentityIdOk returns a tuple with the IdentityId field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetIdentityIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.IdentityId, true
}

// SetIdentityId sets field value
func (o *AuditRecord) SetIdentityId(v string) {
	o.IdentityId = v
}

// GetProcessId returns the ProcessId field value if set, zero value otherwise.
func (o *AuditRecord) GetProcessId() string {
	if o == nil || o.ProcessId == nil {
		var ret string
		return ret
	}
	return *o.ProcessId
}

// GetProcessIdOk returns a tuple with the ProcessId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetProcessIdOk() (*string, bool) {
	if o == nil || o.ProcessId == nil {
		return nil, false
	}
	return o.ProcessId, true
}

// HasProcessId returns a boolean if a field has been set.
func (o *AuditRecord) HasProcessId() bool {
	if o != nil && o.ProcessId != nil {
		return true
	}

	return false
}

// SetProcessId gets a reference to the given string and assigns it to the ProcessId field.
func (o *AuditRecord) SetProcessId(v string) {
	o.ProcessId = &v
}

// GetTargetHandle returns the TargetHandle field value if set, zero value otherwise.
func (o *AuditRecord) GetTargetHandle() string {
	if o == nil || o.TargetHandle == nil {
		var ret string
		return ret
	}
	return *o.TargetHandle
}

// GetTargetHandleOk returns a tuple with the TargetHandle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetTargetHandleOk() (*string, bool) {
	if o == nil || o.TargetHandle == nil {
		return nil, false
	}
	return o.TargetHandle, true
}

// HasTargetHandle returns a boolean if a field has been set.
func (o *AuditRecord) HasTargetHandle() bool {
	if o != nil && o.TargetHandle != nil {
		return true
	}

	return false
}

// SetTargetHandle gets a reference to the given string and assigns it to the TargetHandle field.
func (o *AuditRecord) SetTargetHandle(v string) {
	o.TargetHandle = &v
}

// GetTargetId returns the TargetId field value if set, zero value otherwise.
func (o *AuditRecord) GetTargetId() string {
	if o == nil || o.TargetId == nil {
		var ret string
		return ret
	}
	return *o.TargetId
}

// GetTargetIdOk returns a tuple with the TargetId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetTargetIdOk() (*string, bool) {
	if o == nil || o.TargetId == nil {
		return nil, false
	}
	return o.TargetId, true
}

// HasTargetId returns a boolean if a field has been set.
func (o *AuditRecord) HasTargetId() bool {
	if o != nil && o.TargetId != nil {
		return true
	}

	return false
}

// SetTargetId gets a reference to the given string and assigns it to the TargetId field.
func (o *AuditRecord) SetTargetId(v string) {
	o.TargetId = &v
}

// GetTenantId returns the TenantId field value
func (o *AuditRecord) GetTenantId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TenantId
}

// GetTenantIdOk returns a tuple with the TenantId field value
// and a boolean to check if the value has been set.
func (o *AuditRecord) GetTenantIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TenantId, true
}

// SetTenantId sets field value
func (o *AuditRecord) SetTenantId(v string) {
	o.TenantId = v
}

func (o AuditRecord) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["action_type"] = o.ActionType
	}
	if true {
		toSerialize["actor_avatar_url"] = o.ActorAvatarUrl
	}
	if true {
		toSerialize["actor_display_name"] = o.ActorDisplayName
	}
	if true {
		toSerialize["actor_handle"] = o.ActorHandle
	}
	if true {
		toSerialize["actor_id"] = o.ActorId
	}
	if true {
		toSerialize["actor_ip"] = o.ActorIp
	}
	if true {
		toSerialize["created_at"] = o.CreatedAt
	}
	if true {
		toSerialize["data"] = o.Data
	}
	if true {
		toSerialize["id"] = o.Id
	}
	if true {
		toSerialize["identity_handle"] = o.IdentityHandle
	}
	if true {
		toSerialize["identity_id"] = o.IdentityId
	}
	if o.ProcessId != nil {
		toSerialize["process_id"] = o.ProcessId
	}
	if o.TargetHandle != nil {
		toSerialize["target_handle"] = o.TargetHandle
	}
	if o.TargetId != nil {
		toSerialize["target_id"] = o.TargetId
	}
	if true {
		toSerialize["tenant_id"] = o.TenantId
	}
	return json.Marshal(toSerialize)
}

type NullableAuditRecord struct {
	value *AuditRecord
	isSet bool
}

func (v NullableAuditRecord) Get() *AuditRecord {
	return v.value
}

func (v *NullableAuditRecord) Set(val *AuditRecord) {
	v.value = val
	v.isSet = true
}

func (v NullableAuditRecord) IsSet() bool {
	return v.isSet
}

func (v *NullableAuditRecord) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAuditRecord(val *AuditRecord) *NullableAuditRecord {
	return &NullableAuditRecord{value: val, isSet: true}
}

func (v NullableAuditRecord) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAuditRecord) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
