/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// CreateWorkspaceSnapshotRequest struct for CreateWorkspaceSnapshotRequest
type CreateWorkspaceSnapshotRequest struct {
	Data WorkspaceSnapshotData `json:"data"`
	Tags interface{}           `json:"tags,omitempty"`
	// The title of the snapshot.
	Title *string `json:"title,omitempty"`
	// The visibility of the snapshot to create.
	Visibility *string `json:"visibility,omitempty"`
}

// NewCreateWorkspaceSnapshotRequest instantiates a new CreateWorkspaceSnapshotRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateWorkspaceSnapshotRequest(data WorkspaceSnapshotData) *CreateWorkspaceSnapshotRequest {
	this := CreateWorkspaceSnapshotRequest{}
	this.Data = data
	return &this
}

// NewCreateWorkspaceSnapshotRequestWithDefaults instantiates a new CreateWorkspaceSnapshotRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateWorkspaceSnapshotRequestWithDefaults() *CreateWorkspaceSnapshotRequest {
	this := CreateWorkspaceSnapshotRequest{}
	return &this
}

// GetData returns the Data field value
func (o *CreateWorkspaceSnapshotRequest) GetData() WorkspaceSnapshotData {
	if o == nil {
		var ret WorkspaceSnapshotData
		return ret
	}

	return o.Data
}

// GetDataOk returns a tuple with the Data field value
// and a boolean to check if the value has been set.
func (o *CreateWorkspaceSnapshotRequest) GetDataOk() (*WorkspaceSnapshotData, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Data, true
}

// SetData sets field value
func (o *CreateWorkspaceSnapshotRequest) SetData(v WorkspaceSnapshotData) {
	o.Data = v
}

// GetTags returns the Tags field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *CreateWorkspaceSnapshotRequest) GetTags() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreateWorkspaceSnapshotRequest) GetTagsOk() (*interface{}, bool) {
	if o == nil || o.Tags == nil {
		return nil, false
	}
	return &o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *CreateWorkspaceSnapshotRequest) HasTags() bool {
	if o != nil && o.Tags != nil {
		return true
	}

	return false
}

// SetTags gets a reference to the given interface{} and assigns it to the Tags field.
func (o *CreateWorkspaceSnapshotRequest) SetTags(v interface{}) {
	o.Tags = v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *CreateWorkspaceSnapshotRequest) GetTitle() string {
	if o == nil || o.Title == nil {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateWorkspaceSnapshotRequest) GetTitleOk() (*string, bool) {
	if o == nil || o.Title == nil {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *CreateWorkspaceSnapshotRequest) HasTitle() bool {
	if o != nil && o.Title != nil {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *CreateWorkspaceSnapshotRequest) SetTitle(v string) {
	o.Title = &v
}

// GetVisibility returns the Visibility field value if set, zero value otherwise.
func (o *CreateWorkspaceSnapshotRequest) GetVisibility() string {
	if o == nil || o.Visibility == nil {
		var ret string
		return ret
	}
	return *o.Visibility
}

// GetVisibilityOk returns a tuple with the Visibility field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateWorkspaceSnapshotRequest) GetVisibilityOk() (*string, bool) {
	if o == nil || o.Visibility == nil {
		return nil, false
	}
	return o.Visibility, true
}

// HasVisibility returns a boolean if a field has been set.
func (o *CreateWorkspaceSnapshotRequest) HasVisibility() bool {
	if o != nil && o.Visibility != nil {
		return true
	}

	return false
}

// SetVisibility gets a reference to the given string and assigns it to the Visibility field.
func (o *CreateWorkspaceSnapshotRequest) SetVisibility(v string) {
	o.Visibility = &v
}

func (o CreateWorkspaceSnapshotRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["data"] = o.Data
	}
	if o.Tags != nil {
		toSerialize["tags"] = o.Tags
	}
	if o.Title != nil {
		toSerialize["title"] = o.Title
	}
	if o.Visibility != nil {
		toSerialize["visibility"] = o.Visibility
	}
	return json.Marshal(toSerialize)
}

type NullableCreateWorkspaceSnapshotRequest struct {
	value *CreateWorkspaceSnapshotRequest
	isSet bool
}

func (v NullableCreateWorkspaceSnapshotRequest) Get() *CreateWorkspaceSnapshotRequest {
	return v.value
}

func (v *NullableCreateWorkspaceSnapshotRequest) Set(val *CreateWorkspaceSnapshotRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateWorkspaceSnapshotRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateWorkspaceSnapshotRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateWorkspaceSnapshotRequest(val *CreateWorkspaceSnapshotRequest) *NullableCreateWorkspaceSnapshotRequest {
	return &NullableCreateWorkspaceSnapshotRequest{value: val, isSet: true}
}

func (v NullableCreateWorkspaceSnapshotRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateWorkspaceSnapshotRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
