/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListConnectionsResponse struct for ListConnectionsResponse
type ListConnectionsResponse struct {
	Items     *[]Connection `json:"items,omitempty"`
	NextToken *string       `json:"next_token,omitempty"`
}

// NewListConnectionsResponse instantiates a new ListConnectionsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListConnectionsResponse() *ListConnectionsResponse {
	this := ListConnectionsResponse{}
	return &this
}

// NewListConnectionsResponseWithDefaults instantiates a new ListConnectionsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListConnectionsResponseWithDefaults() *ListConnectionsResponse {
	this := ListConnectionsResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListConnectionsResponse) GetItems() []Connection {
	if o == nil || o.Items == nil {
		var ret []Connection
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListConnectionsResponse) GetItemsOk() (*[]Connection, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListConnectionsResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []Connection and assigns it to the Items field.
func (o *ListConnectionsResponse) SetItems(v []Connection) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListConnectionsResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListConnectionsResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListConnectionsResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListConnectionsResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListConnectionsResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListConnectionsResponse struct {
	value *ListConnectionsResponse
	isSet bool
}

func (v NullableListConnectionsResponse) Get() *ListConnectionsResponse {
	return v.value
}

func (v *NullableListConnectionsResponse) Set(val *ListConnectionsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListConnectionsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListConnectionsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListConnectionsResponse(val *ListConnectionsResponse) *NullableListConnectionsResponse {
	return &NullableListConnectionsResponse{value: val, isSet: true}
}

func (v NullableListConnectionsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListConnectionsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
