/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListProcessesResponse struct for ListProcessesResponse
type ListProcessesResponse struct {
	Items     *[]SpProcess `json:"items,omitempty"`
	NextToken *string      `json:"next_token,omitempty"`
}

// NewListProcessesResponse instantiates a new ListProcessesResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListProcessesResponse() *ListProcessesResponse {
	this := ListProcessesResponse{}
	return &this
}

// NewListProcessesResponseWithDefaults instantiates a new ListProcessesResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListProcessesResponseWithDefaults() *ListProcessesResponse {
	this := ListProcessesResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListProcessesResponse) GetItems() []SpProcess {
	if o == nil || o.Items == nil {
		var ret []SpProcess
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListProcessesResponse) GetItemsOk() (*[]SpProcess, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListProcessesResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []SpProcess and assigns it to the Items field.
func (o *ListProcessesResponse) SetItems(v []SpProcess) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListProcessesResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListProcessesResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListProcessesResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListProcessesResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListProcessesResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListProcessesResponse struct {
	value *ListProcessesResponse
	isSet bool
}

func (v NullableListProcessesResponse) Get() *ListProcessesResponse {
	return v.value
}

func (v *NullableListProcessesResponse) Set(val *ListProcessesResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListProcessesResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListProcessesResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListProcessesResponse(val *ListProcessesResponse) *NullableListProcessesResponse {
	return &NullableListProcessesResponse{value: val, isSet: true}
}

func (v NullableListProcessesResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListProcessesResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
