/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListUserOrgsResponse struct for ListUserOrgsResponse
type ListUserOrgsResponse struct {
	Items     *[]UserOrg `json:"items,omitempty"`
	NextToken *string    `json:"next_token,omitempty"`
}

// NewListUserOrgsResponse instantiates a new ListUserOrgsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListUserOrgsResponse() *ListUserOrgsResponse {
	this := ListUserOrgsResponse{}
	return &this
}

// NewListUserOrgsResponseWithDefaults instantiates a new ListUserOrgsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListUserOrgsResponseWithDefaults() *ListUserOrgsResponse {
	this := ListUserOrgsResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListUserOrgsResponse) GetItems() []UserOrg {
	if o == nil || o.Items == nil {
		var ret []UserOrg
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListUserOrgsResponse) GetItemsOk() (*[]UserOrg, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListUserOrgsResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []UserOrg and assigns it to the Items field.
func (o *ListUserOrgsResponse) SetItems(v []UserOrg) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListUserOrgsResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListUserOrgsResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListUserOrgsResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListUserOrgsResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListUserOrgsResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListUserOrgsResponse struct {
	value *ListUserOrgsResponse
	isSet bool
}

func (v NullableListUserOrgsResponse) Get() *ListUserOrgsResponse {
	return v.value
}

func (v *NullableListUserOrgsResponse) Set(val *ListUserOrgsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListUserOrgsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListUserOrgsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListUserOrgsResponse(val *ListUserOrgsResponse) *NullableListUserOrgsResponse {
	return &NullableListUserOrgsResponse{value: val, isSet: true}
}

func (v NullableListUserOrgsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListUserOrgsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
