/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListWorkspaceConnResponse struct for ListWorkspaceConnResponse
type ListWorkspaceConnResponse struct {
	Items     *[]WorkspaceConn `json:"items,omitempty"`
	NextToken *string          `json:"next_token,omitempty"`
}

// NewListWorkspaceConnResponse instantiates a new ListWorkspaceConnResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListWorkspaceConnResponse() *ListWorkspaceConnResponse {
	this := ListWorkspaceConnResponse{}
	return &this
}

// NewListWorkspaceConnResponseWithDefaults instantiates a new ListWorkspaceConnResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListWorkspaceConnResponseWithDefaults() *ListWorkspaceConnResponse {
	this := ListWorkspaceConnResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListWorkspaceConnResponse) GetItems() []WorkspaceConn {
	if o == nil || o.Items == nil {
		var ret []WorkspaceConn
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListWorkspaceConnResponse) GetItemsOk() (*[]WorkspaceConn, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListWorkspaceConnResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []WorkspaceConn and assigns it to the Items field.
func (o *ListWorkspaceConnResponse) SetItems(v []WorkspaceConn) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListWorkspaceConnResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListWorkspaceConnResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListWorkspaceConnResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListWorkspaceConnResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListWorkspaceConnResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListWorkspaceConnResponse struct {
	value *ListWorkspaceConnResponse
	isSet bool
}

func (v NullableListWorkspaceConnResponse) Get() *ListWorkspaceConnResponse {
	return v.value
}

func (v *NullableListWorkspaceConnResponse) Set(val *ListWorkspaceConnResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListWorkspaceConnResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListWorkspaceConnResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListWorkspaceConnResponse(val *ListWorkspaceConnResponse) *NullableListWorkspaceConnResponse {
	return &NullableListWorkspaceConnResponse{value: val, isSet: true}
}

func (v NullableListWorkspaceConnResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListWorkspaceConnResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
