/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListWorkspaceSchemaResponse struct for ListWorkspaceSchemaResponse
type ListWorkspaceSchemaResponse struct {
	Items     *[]WorkspaceSchema `json:"items,omitempty"`
	NextToken *string            `json:"next_token,omitempty"`
}

// NewListWorkspaceSchemaResponse instantiates a new ListWorkspaceSchemaResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListWorkspaceSchemaResponse() *ListWorkspaceSchemaResponse {
	this := ListWorkspaceSchemaResponse{}
	return &this
}

// NewListWorkspaceSchemaResponseWithDefaults instantiates a new ListWorkspaceSchemaResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListWorkspaceSchemaResponseWithDefaults() *ListWorkspaceSchemaResponse {
	this := ListWorkspaceSchemaResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListWorkspaceSchemaResponse) GetItems() []WorkspaceSchema {
	if o == nil || o.Items == nil {
		var ret []WorkspaceSchema
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListWorkspaceSchemaResponse) GetItemsOk() (*[]WorkspaceSchema, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListWorkspaceSchemaResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []WorkspaceSchema and assigns it to the Items field.
func (o *ListWorkspaceSchemaResponse) SetItems(v []WorkspaceSchema) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListWorkspaceSchemaResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListWorkspaceSchemaResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListWorkspaceSchemaResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListWorkspaceSchemaResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListWorkspaceSchemaResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListWorkspaceSchemaResponse struct {
	value *ListWorkspaceSchemaResponse
	isSet bool
}

func (v NullableListWorkspaceSchemaResponse) Get() *ListWorkspaceSchemaResponse {
	return v.value
}

func (v *NullableListWorkspaceSchemaResponse) Set(val *ListWorkspaceSchemaResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListWorkspaceSchemaResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListWorkspaceSchemaResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListWorkspaceSchemaResponse(val *ListWorkspaceSchemaResponse) *NullableListWorkspaceSchemaResponse {
	return &NullableListWorkspaceSchemaResponse{value: val, isSet: true}
}

func (v NullableListWorkspaceSchemaResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListWorkspaceSchemaResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
