/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// TenantSamlLoginSettings struct for TenantSamlLoginSettings
type TenantSamlLoginSettings struct {
	// The IdP public x509 certificate in PEM format.
	Certificate *string `json:"certificate,omitempty"`
	// The IdP issuer.
	Issuer *string `json:"issuer,omitempty"`
	// The IdP SSO URL.
	SsoUrl *string `json:"sso_url,omitempty"`
	State  string  `json:"state"`
	Type   string  `json:"type"`
}

// NewTenantSamlLoginSettings instantiates a new TenantSamlLoginSettings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTenantSamlLoginSettings(state string, type_ string) *TenantSamlLoginSettings {
	this := TenantSamlLoginSettings{}
	this.State = state
	this.Type = type_
	return &this
}

// NewTenantSamlLoginSettingsWithDefaults instantiates a new TenantSamlLoginSettings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTenantSamlLoginSettingsWithDefaults() *TenantSamlLoginSettings {
	this := TenantSamlLoginSettings{}
	return &this
}

// GetCertificate returns the Certificate field value if set, zero value otherwise.
func (o *TenantSamlLoginSettings) GetCertificate() string {
	if o == nil || o.Certificate == nil {
		var ret string
		return ret
	}
	return *o.Certificate
}

// GetCertificateOk returns a tuple with the Certificate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TenantSamlLoginSettings) GetCertificateOk() (*string, bool) {
	if o == nil || o.Certificate == nil {
		return nil, false
	}
	return o.Certificate, true
}

// HasCertificate returns a boolean if a field has been set.
func (o *TenantSamlLoginSettings) HasCertificate() bool {
	if o != nil && o.Certificate != nil {
		return true
	}

	return false
}

// SetCertificate gets a reference to the given string and assigns it to the Certificate field.
func (o *TenantSamlLoginSettings) SetCertificate(v string) {
	o.Certificate = &v
}

// GetIssuer returns the Issuer field value if set, zero value otherwise.
func (o *TenantSamlLoginSettings) GetIssuer() string {
	if o == nil || o.Issuer == nil {
		var ret string
		return ret
	}
	return *o.Issuer
}

// GetIssuerOk returns a tuple with the Issuer field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TenantSamlLoginSettings) GetIssuerOk() (*string, bool) {
	if o == nil || o.Issuer == nil {
		return nil, false
	}
	return o.Issuer, true
}

// HasIssuer returns a boolean if a field has been set.
func (o *TenantSamlLoginSettings) HasIssuer() bool {
	if o != nil && o.Issuer != nil {
		return true
	}

	return false
}

// SetIssuer gets a reference to the given string and assigns it to the Issuer field.
func (o *TenantSamlLoginSettings) SetIssuer(v string) {
	o.Issuer = &v
}

// GetSsoUrl returns the SsoUrl field value if set, zero value otherwise.
func (o *TenantSamlLoginSettings) GetSsoUrl() string {
	if o == nil || o.SsoUrl == nil {
		var ret string
		return ret
	}
	return *o.SsoUrl
}

// GetSsoUrlOk returns a tuple with the SsoUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TenantSamlLoginSettings) GetSsoUrlOk() (*string, bool) {
	if o == nil || o.SsoUrl == nil {
		return nil, false
	}
	return o.SsoUrl, true
}

// HasSsoUrl returns a boolean if a field has been set.
func (o *TenantSamlLoginSettings) HasSsoUrl() bool {
	if o != nil && o.SsoUrl != nil {
		return true
	}

	return false
}

// SetSsoUrl gets a reference to the given string and assigns it to the SsoUrl field.
func (o *TenantSamlLoginSettings) SetSsoUrl(v string) {
	o.SsoUrl = &v
}

// GetState returns the State field value
func (o *TenantSamlLoginSettings) GetState() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.State
}

// GetStateOk returns a tuple with the State field value
// and a boolean to check if the value has been set.
func (o *TenantSamlLoginSettings) GetStateOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.State, true
}

// SetState sets field value
func (o *TenantSamlLoginSettings) SetState(v string) {
	o.State = v
}

// GetType returns the Type field value
func (o *TenantSamlLoginSettings) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *TenantSamlLoginSettings) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *TenantSamlLoginSettings) SetType(v string) {
	o.Type = v
}

func (o TenantSamlLoginSettings) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Certificate != nil {
		toSerialize["certificate"] = o.Certificate
	}
	if o.Issuer != nil {
		toSerialize["issuer"] = o.Issuer
	}
	if o.SsoUrl != nil {
		toSerialize["sso_url"] = o.SsoUrl
	}
	if true {
		toSerialize["state"] = o.State
	}
	if true {
		toSerialize["type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullableTenantSamlLoginSettings struct {
	value *TenantSamlLoginSettings
	isSet bool
}

func (v NullableTenantSamlLoginSettings) Get() *TenantSamlLoginSettings {
	return v.value
}

func (v *NullableTenantSamlLoginSettings) Set(val *TenantSamlLoginSettings) {
	v.value = val
	v.isSet = true
}

func (v NullableTenantSamlLoginSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableTenantSamlLoginSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTenantSamlLoginSettings(val *TenantSamlLoginSettings) *NullableTenantSamlLoginSettings {
	return &NullableTenantSamlLoginSettings{value: val, isSet: true}
}

func (v NullableTenantSamlLoginSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTenantSamlLoginSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
