/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// TenantSettings struct for TenantSettings
type TenantSettings struct {
	// The time of creation in ISO 8601 UTC.
	CreatedAt string `json:"created_at"`
	CreatedBy *User  `json:"created_by,omitempty"`
	// The ID of the user that created this.
	CreatedById string                  `json:"created_by_id"`
	LoginEmail  TenantLoginSettings     `json:"login_email"`
	LoginGithub TenantLoginSettings     `json:"login_github"`
	LoginGoogle TenantLoginSettings     `json:"login_google"`
	LoginSaml   TenantSamlLoginSettings `json:"login_saml"`
	// The time of the last update in ISO 8601 UTC.
	UpdatedAt *string `json:"updated_at,omitempty"`
	UpdatedBy *User   `json:"updated_by,omitempty"`
	// The ID of the user that performed the last update.
	UpdatedById string `json:"updated_by_id"`
	// The user provisioning settings for the tenant.
	UserProvisioning []string `json:"user_provisioning"`
	// The domains that new users are permitted to be provisioned from.
	UserProvisioningPermittedDomains []string `json:"user_provisioning_permitted_domains"`
	// The current version of the user setting.
	VersionId int32 `json:"version_id"`
}

// NewTenantSettings instantiates a new TenantSettings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTenantSettings(createdAt string, createdById string, loginEmail TenantLoginSettings, loginGithub TenantLoginSettings, loginGoogle TenantLoginSettings, loginSaml TenantSamlLoginSettings, updatedById string, userProvisioning []string, userProvisioningPermittedDomains []string, versionId int32) *TenantSettings {
	this := TenantSettings{}
	this.CreatedAt = createdAt
	this.CreatedById = createdById
	this.LoginEmail = loginEmail
	this.LoginGithub = loginGithub
	this.LoginGoogle = loginGoogle
	this.LoginSaml = loginSaml
	this.UpdatedById = updatedById
	this.UserProvisioning = userProvisioning
	this.UserProvisioningPermittedDomains = userProvisioningPermittedDomains
	this.VersionId = versionId
	return &this
}

// NewTenantSettingsWithDefaults instantiates a new TenantSettings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTenantSettingsWithDefaults() *TenantSettings {
	this := TenantSettings{}
	return &this
}

// GetCreatedAt returns the CreatedAt field value
func (o *TenantSettings) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *TenantSettings) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetCreatedBy returns the CreatedBy field value if set, zero value otherwise.
func (o *TenantSettings) GetCreatedBy() User {
	if o == nil || o.CreatedBy == nil {
		var ret User
		return ret
	}
	return *o.CreatedBy
}

// GetCreatedByOk returns a tuple with the CreatedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetCreatedByOk() (*User, bool) {
	if o == nil || o.CreatedBy == nil {
		return nil, false
	}
	return o.CreatedBy, true
}

// HasCreatedBy returns a boolean if a field has been set.
func (o *TenantSettings) HasCreatedBy() bool {
	if o != nil && o.CreatedBy != nil {
		return true
	}

	return false
}

// SetCreatedBy gets a reference to the given User and assigns it to the CreatedBy field.
func (o *TenantSettings) SetCreatedBy(v User) {
	o.CreatedBy = &v
}

// GetCreatedById returns the CreatedById field value
func (o *TenantSettings) GetCreatedById() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedById
}

// GetCreatedByIdOk returns a tuple with the CreatedById field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetCreatedByIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedById, true
}

// SetCreatedById sets field value
func (o *TenantSettings) SetCreatedById(v string) {
	o.CreatedById = v
}

// GetLoginEmail returns the LoginEmail field value
func (o *TenantSettings) GetLoginEmail() TenantLoginSettings {
	if o == nil {
		var ret TenantLoginSettings
		return ret
	}

	return o.LoginEmail
}

// GetLoginEmailOk returns a tuple with the LoginEmail field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetLoginEmailOk() (*TenantLoginSettings, bool) {
	if o == nil {
		return nil, false
	}
	return &o.LoginEmail, true
}

// SetLoginEmail sets field value
func (o *TenantSettings) SetLoginEmail(v TenantLoginSettings) {
	o.LoginEmail = v
}

// GetLoginGithub returns the LoginGithub field value
func (o *TenantSettings) GetLoginGithub() TenantLoginSettings {
	if o == nil {
		var ret TenantLoginSettings
		return ret
	}

	return o.LoginGithub
}

// GetLoginGithubOk returns a tuple with the LoginGithub field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetLoginGithubOk() (*TenantLoginSettings, bool) {
	if o == nil {
		return nil, false
	}
	return &o.LoginGithub, true
}

// SetLoginGithub sets field value
func (o *TenantSettings) SetLoginGithub(v TenantLoginSettings) {
	o.LoginGithub = v
}

// GetLoginGoogle returns the LoginGoogle field value
func (o *TenantSettings) GetLoginGoogle() TenantLoginSettings {
	if o == nil {
		var ret TenantLoginSettings
		return ret
	}

	return o.LoginGoogle
}

// GetLoginGoogleOk returns a tuple with the LoginGoogle field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetLoginGoogleOk() (*TenantLoginSettings, bool) {
	if o == nil {
		return nil, false
	}
	return &o.LoginGoogle, true
}

// SetLoginGoogle sets field value
func (o *TenantSettings) SetLoginGoogle(v TenantLoginSettings) {
	o.LoginGoogle = v
}

// GetLoginSaml returns the LoginSaml field value
func (o *TenantSettings) GetLoginSaml() TenantSamlLoginSettings {
	if o == nil {
		var ret TenantSamlLoginSettings
		return ret
	}

	return o.LoginSaml
}

// GetLoginSamlOk returns a tuple with the LoginSaml field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetLoginSamlOk() (*TenantSamlLoginSettings, bool) {
	if o == nil {
		return nil, false
	}
	return &o.LoginSaml, true
}

// SetLoginSaml sets field value
func (o *TenantSettings) SetLoginSaml(v TenantSamlLoginSettings) {
	o.LoginSaml = v
}

// GetUpdatedAt returns the UpdatedAt field value if set, zero value otherwise.
func (o *TenantSettings) GetUpdatedAt() string {
	if o == nil || o.UpdatedAt == nil {
		var ret string
		return ret
	}
	return *o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetUpdatedAtOk() (*string, bool) {
	if o == nil || o.UpdatedAt == nil {
		return nil, false
	}
	return o.UpdatedAt, true
}

// HasUpdatedAt returns a boolean if a field has been set.
func (o *TenantSettings) HasUpdatedAt() bool {
	if o != nil && o.UpdatedAt != nil {
		return true
	}

	return false
}

// SetUpdatedAt gets a reference to the given string and assigns it to the UpdatedAt field.
func (o *TenantSettings) SetUpdatedAt(v string) {
	o.UpdatedAt = &v
}

// GetUpdatedBy returns the UpdatedBy field value if set, zero value otherwise.
func (o *TenantSettings) GetUpdatedBy() User {
	if o == nil || o.UpdatedBy == nil {
		var ret User
		return ret
	}
	return *o.UpdatedBy
}

// GetUpdatedByOk returns a tuple with the UpdatedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetUpdatedByOk() (*User, bool) {
	if o == nil || o.UpdatedBy == nil {
		return nil, false
	}
	return o.UpdatedBy, true
}

// HasUpdatedBy returns a boolean if a field has been set.
func (o *TenantSettings) HasUpdatedBy() bool {
	if o != nil && o.UpdatedBy != nil {
		return true
	}

	return false
}

// SetUpdatedBy gets a reference to the given User and assigns it to the UpdatedBy field.
func (o *TenantSettings) SetUpdatedBy(v User) {
	o.UpdatedBy = &v
}

// GetUpdatedById returns the UpdatedById field value
func (o *TenantSettings) GetUpdatedById() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UpdatedById
}

// GetUpdatedByIdOk returns a tuple with the UpdatedById field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetUpdatedByIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedById, true
}

// SetUpdatedById sets field value
func (o *TenantSettings) SetUpdatedById(v string) {
	o.UpdatedById = v
}

// GetUserProvisioning returns the UserProvisioning field value
func (o *TenantSettings) GetUserProvisioning() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.UserProvisioning
}

// GetUserProvisioningOk returns a tuple with the UserProvisioning field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetUserProvisioningOk() (*[]string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UserProvisioning, true
}

// SetUserProvisioning sets field value
func (o *TenantSettings) SetUserProvisioning(v []string) {
	o.UserProvisioning = v
}

// GetUserProvisioningPermittedDomains returns the UserProvisioningPermittedDomains field value
func (o *TenantSettings) GetUserProvisioningPermittedDomains() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.UserProvisioningPermittedDomains
}

// GetUserProvisioningPermittedDomainsOk returns a tuple with the UserProvisioningPermittedDomains field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetUserProvisioningPermittedDomainsOk() (*[]string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UserProvisioningPermittedDomains, true
}

// SetUserProvisioningPermittedDomains sets field value
func (o *TenantSettings) SetUserProvisioningPermittedDomains(v []string) {
	o.UserProvisioningPermittedDomains = v
}

// GetVersionId returns the VersionId field value
func (o *TenantSettings) GetVersionId() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.VersionId
}

// GetVersionIdOk returns a tuple with the VersionId field value
// and a boolean to check if the value has been set.
func (o *TenantSettings) GetVersionIdOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.VersionId, true
}

// SetVersionId sets field value
func (o *TenantSettings) SetVersionId(v int32) {
	o.VersionId = v
}

func (o TenantSettings) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["created_at"] = o.CreatedAt
	}
	if o.CreatedBy != nil {
		toSerialize["created_by"] = o.CreatedBy
	}
	if true {
		toSerialize["created_by_id"] = o.CreatedById
	}
	if true {
		toSerialize["login_email"] = o.LoginEmail
	}
	if true {
		toSerialize["login_github"] = o.LoginGithub
	}
	if true {
		toSerialize["login_google"] = o.LoginGoogle
	}
	if true {
		toSerialize["login_saml"] = o.LoginSaml
	}
	if o.UpdatedAt != nil {
		toSerialize["updated_at"] = o.UpdatedAt
	}
	if o.UpdatedBy != nil {
		toSerialize["updated_by"] = o.UpdatedBy
	}
	if true {
		toSerialize["updated_by_id"] = o.UpdatedById
	}
	if true {
		toSerialize["user_provisioning"] = o.UserProvisioning
	}
	if true {
		toSerialize["user_provisioning_permitted_domains"] = o.UserProvisioningPermittedDomains
	}
	if true {
		toSerialize["version_id"] = o.VersionId
	}
	return json.Marshal(toSerialize)
}

type NullableTenantSettings struct {
	value *TenantSettings
	isSet bool
}

func (v NullableTenantSettings) Get() *TenantSettings {
	return v.value
}

func (v *NullableTenantSettings) Set(val *TenantSettings) {
	v.value = val
	v.isSet = true
}

func (v NullableTenantSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableTenantSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTenantSettings(val *TenantSettings) *NullableTenantSettings {
	return &NullableTenantSettings{value: val, isSet: true}
}

func (v NullableTenantSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTenantSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
