/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// UpdateWorkspaceAggregatorRequest struct for UpdateWorkspaceAggregatorRequest
type UpdateWorkspaceAggregatorRequest struct {
	// The connections that are a part of the aggregator.
	Connections *[]string `json:"connections,omitempty"`
	// The handle of the aggregator.
	Handle *string `json:"handle,omitempty"`
}

// NewUpdateWorkspaceAggregatorRequest instantiates a new UpdateWorkspaceAggregatorRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUpdateWorkspaceAggregatorRequest() *UpdateWorkspaceAggregatorRequest {
	this := UpdateWorkspaceAggregatorRequest{}
	return &this
}

// NewUpdateWorkspaceAggregatorRequestWithDefaults instantiates a new UpdateWorkspaceAggregatorRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUpdateWorkspaceAggregatorRequestWithDefaults() *UpdateWorkspaceAggregatorRequest {
	this := UpdateWorkspaceAggregatorRequest{}
	return &this
}

// GetConnections returns the Connections field value if set, zero value otherwise.
func (o *UpdateWorkspaceAggregatorRequest) GetConnections() []string {
	if o == nil || o.Connections == nil {
		var ret []string
		return ret
	}
	return *o.Connections
}

// GetConnectionsOk returns a tuple with the Connections field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateWorkspaceAggregatorRequest) GetConnectionsOk() (*[]string, bool) {
	if o == nil || o.Connections == nil {
		return nil, false
	}
	return o.Connections, true
}

// HasConnections returns a boolean if a field has been set.
func (o *UpdateWorkspaceAggregatorRequest) HasConnections() bool {
	if o != nil && o.Connections != nil {
		return true
	}

	return false
}

// SetConnections gets a reference to the given []string and assigns it to the Connections field.
func (o *UpdateWorkspaceAggregatorRequest) SetConnections(v []string) {
	o.Connections = &v
}

// GetHandle returns the Handle field value if set, zero value otherwise.
func (o *UpdateWorkspaceAggregatorRequest) GetHandle() string {
	if o == nil || o.Handle == nil {
		var ret string
		return ret
	}
	return *o.Handle
}

// GetHandleOk returns a tuple with the Handle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateWorkspaceAggregatorRequest) GetHandleOk() (*string, bool) {
	if o == nil || o.Handle == nil {
		return nil, false
	}
	return o.Handle, true
}

// HasHandle returns a boolean if a field has been set.
func (o *UpdateWorkspaceAggregatorRequest) HasHandle() bool {
	if o != nil && o.Handle != nil {
		return true
	}

	return false
}

// SetHandle gets a reference to the given string and assigns it to the Handle field.
func (o *UpdateWorkspaceAggregatorRequest) SetHandle(v string) {
	o.Handle = &v
}

func (o UpdateWorkspaceAggregatorRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Connections != nil {
		toSerialize["connections"] = o.Connections
	}
	if o.Handle != nil {
		toSerialize["handle"] = o.Handle
	}
	return json.Marshal(toSerialize)
}

type NullableUpdateWorkspaceAggregatorRequest struct {
	value *UpdateWorkspaceAggregatorRequest
	isSet bool
}

func (v NullableUpdateWorkspaceAggregatorRequest) Get() *UpdateWorkspaceAggregatorRequest {
	return v.value
}

func (v *NullableUpdateWorkspaceAggregatorRequest) Set(val *UpdateWorkspaceAggregatorRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableUpdateWorkspaceAggregatorRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableUpdateWorkspaceAggregatorRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUpdateWorkspaceAggregatorRequest(val *UpdateWorkspaceAggregatorRequest) *NullableUpdateWorkspaceAggregatorRequest {
	return &NullableUpdateWorkspaceAggregatorRequest{value: val, isSet: true}
}

func (v NullableUpdateWorkspaceAggregatorRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUpdateWorkspaceAggregatorRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
