/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// UserDatabasePassword struct for UserDatabasePassword
type UserDatabasePassword struct {
	Password  string  `json:"$password"`
	CreatedAt string  `json:"created_at"`
	ExpiresAt *string `json:"expires_at,omitempty"`
	Id        string  `json:"id"`
	UserId    *string `json:"user_id,omitempty"`
}

// NewUserDatabasePassword instantiates a new UserDatabasePassword object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserDatabasePassword(password string, createdAt string, id string) *UserDatabasePassword {
	this := UserDatabasePassword{}
	this.Password = password
	this.CreatedAt = createdAt
	this.Id = id
	return &this
}

// NewUserDatabasePasswordWithDefaults instantiates a new UserDatabasePassword object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserDatabasePasswordWithDefaults() *UserDatabasePassword {
	this := UserDatabasePassword{}
	return &this
}

// GetPassword returns the Password field value
func (o *UserDatabasePassword) GetPassword() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Password
}

// GetPasswordOk returns a tuple with the Password field value
// and a boolean to check if the value has been set.
func (o *UserDatabasePassword) GetPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Password, true
}

// SetPassword sets field value
func (o *UserDatabasePassword) SetPassword(v string) {
	o.Password = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *UserDatabasePassword) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *UserDatabasePassword) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *UserDatabasePassword) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetExpiresAt returns the ExpiresAt field value if set, zero value otherwise.
func (o *UserDatabasePassword) GetExpiresAt() string {
	if o == nil || o.ExpiresAt == nil {
		var ret string
		return ret
	}
	return *o.ExpiresAt
}

// GetExpiresAtOk returns a tuple with the ExpiresAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserDatabasePassword) GetExpiresAtOk() (*string, bool) {
	if o == nil || o.ExpiresAt == nil {
		return nil, false
	}
	return o.ExpiresAt, true
}

// HasExpiresAt returns a boolean if a field has been set.
func (o *UserDatabasePassword) HasExpiresAt() bool {
	if o != nil && o.ExpiresAt != nil {
		return true
	}

	return false
}

// SetExpiresAt gets a reference to the given string and assigns it to the ExpiresAt field.
func (o *UserDatabasePassword) SetExpiresAt(v string) {
	o.ExpiresAt = &v
}

// GetId returns the Id field value
func (o *UserDatabasePassword) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *UserDatabasePassword) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *UserDatabasePassword) SetId(v string) {
	o.Id = v
}

// GetUserId returns the UserId field value if set, zero value otherwise.
func (o *UserDatabasePassword) GetUserId() string {
	if o == nil || o.UserId == nil {
		var ret string
		return ret
	}
	return *o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserDatabasePassword) GetUserIdOk() (*string, bool) {
	if o == nil || o.UserId == nil {
		return nil, false
	}
	return o.UserId, true
}

// HasUserId returns a boolean if a field has been set.
func (o *UserDatabasePassword) HasUserId() bool {
	if o != nil && o.UserId != nil {
		return true
	}

	return false
}

// SetUserId gets a reference to the given string and assigns it to the UserId field.
func (o *UserDatabasePassword) SetUserId(v string) {
	o.UserId = &v
}

func (o UserDatabasePassword) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["$password"] = o.Password
	}
	if true {
		toSerialize["created_at"] = o.CreatedAt
	}
	if o.ExpiresAt != nil {
		toSerialize["expires_at"] = o.ExpiresAt
	}
	if true {
		toSerialize["id"] = o.Id
	}
	if o.UserId != nil {
		toSerialize["user_id"] = o.UserId
	}
	return json.Marshal(toSerialize)
}

type NullableUserDatabasePassword struct {
	value *UserDatabasePassword
	isSet bool
}

func (v NullableUserDatabasePassword) Get() *UserDatabasePassword {
	return v.value
}

func (v *NullableUserDatabasePassword) Set(val *UserDatabasePassword) {
	v.value = val
	v.isSet = true
}

func (v NullableUserDatabasePassword) IsSet() bool {
	return v.isSet
}

func (v *NullableUserDatabasePassword) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserDatabasePassword(val *UserDatabasePassword) *NullableUserDatabasePassword {
	return &NullableUserDatabasePassword{value: val, isSet: true}
}

func (v NullableUserDatabasePassword) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserDatabasePassword) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
